﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CodePrufera
{
    internal class MethodsClass
    {
        public string Path { get; set; }
        public MethodsClass(string path)
        {
            Path = path;
        }

        private int[,] reading()
        {
            int n = File.ReadAllLines(Path).Length;
            int[,] graph = new int[n, 2];
            using (StreamReader reader = new StreamReader(Path))
            {
                for (int i = 0; i < n; i++)
                {
                    string text = reader.ReadLine();
                    string[] mas = text.Split(new char[] { ' ' });
                    for (int j = 0; j < mas.Length; j++)
                    {
                        graph[i,j]=(int.Parse(mas[j]));
                    }

                }

            }
            return graph;
        }

        public void CodeingTree()
        {
            int [,] ribs = reading();
            int n = ribs.GetLength(0) + 1;
            List<int>[] tree = new List<int>[n + 1];
            for (int i = 0; i <= n; i++)
                tree[i] = new List<int>();  


            for (int i = 0; i < ribs.GetLength(0); i++)
            {
                int u = ribs[i,0];
                int v = ribs[i, 1];
                tree[u].Add(v);
                tree[v].Add(u);
            }
            int[] degree = new int[n + 1];
            for (int i = 1; i <= n; i++)
                degree[i] = tree[i].Count;
            SortedSet<int> leaves = new SortedSet<int>();
            for (int i = 1; i <= n; i++)
            {
                if (degree[i] == 1)
                    leaves.Add(i);
            }

            List<int> pruferCode = new List<int>();
            for (int i = 0; i < n - 2; i++)
            {
                int leaf = leaves.First();
                leaves.Remove(leaf);

                int neighbor = tree[leaf].First();
                pruferCode.Add(neighbor);

                degree[neighbor]--;
                if (degree[neighbor] == 1)
                    leaves.Add(neighbor);

                tree[leaf].Remove(neighbor);
                tree[neighbor].Remove(leaf);
            }
            writing(pruferCode);
        }

        private void writing(List<int> graph)
        {
            FileStream file1 = new FileStream("itog.txt", FileMode.OpenOrCreate);
            StreamWriter writer = new StreamWriter(file1);
            writer.WriteLine("Код Прюфера: ");
            for (int i = 0; i < graph.Count; i++)
            {
                writer.Write(graph[i] + " ");
            }
            writer.Close();
        }
        
    }
}
